/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length != 11) {
			return callback('手机号输入有问题');
		}
		if (loginInfo.password.length ==0) {
			return callback('请输入密码');
		}
		var severUrl=owner.getseverUrl()+"home/login";
		mui.ajax(severUrl,{
			data:{
				PhoneNum:loginInfo.account,
				PassWord:loginInfo.password
			},
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:50000,//超时时间设置为3分钟；
			success:function(data){//服务器返回响应，根据响应结果，分析是否登录成功；
				if(data.IsOk)
				{
					localStorage.setItem('$users', '[]');
					var users = JSON.parse(localStorage.getItem('$users') || '[]');
					if(users.length<=0)
					{
						users.push(data);
					}
					owner.setUser(users);
					return owner.createState(loginInfo.account, callback);
				}
				else
				{
					return callback(data.Msg);
				}
			},
			error:function(xhr,type,errorThrown){
				state='{}',
				owner.setState(state);
				return callback('请求超时');
			}
		});
	};

	owner.createState = function(name, callback) {
		var state = owner.getState();
		state.account = name;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.phone = regInfo.phone || '';
		regInfo.password = regInfo.password || '';
		regInfo.code = regInfo.code||'';
		regInfo.refereesText = regInfo.refereesText||'';
		
		
		if (regInfo.phone.length !=11) {
			return callback('手机号输入有误');
		}
		if (regInfo.password.length<8 ||regInfo.password.length>18) {
			return callback('密码8-18位由字母、数字或符号组成');
		}
		if(regInfo.phone=="" ||regInfo.password=="" ||regInfo.code==""){
			return callback('全为必填项');
		}
		//owner.getseverUrl()+
		var severUrl=owner.getseverUrl()+"home/Register";
		mui.ajax(severUrl,{
			data:{
				ChannelCode:'app',
				PassWord:regInfo.password,
				PhoneNum:regInfo.phone,
				RefererPhoneNum:regInfo.refereesText,
				ValCode:regInfo.code,
				NeedCheckCode:true
			},
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:50000,//超时时间设置为3分钟；
			success:function(data){//服务器返回响应，根据响应结果，分析是否登录成功；
				if(data.IsOk)
				{
					return callback();
				}
				else
				{
					return callback(data.Msg);
				}
			},
			error:function(xhr,type,errorThrown){
				state='{}',
				owner.setState(state);
				return callback('请求超时');
			}
		});
	};

	//设置User数据
	owner.setUser=function(user){
		user = user || {};
		localStorage.setItem('$users', JSON.stringify(user));
	}

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};
	
	/**
	 * 获取当前用户
	 **/
	owner.getUser = function() {
		var stateText = localStorage.getItem('$users') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	var checkIdnumOrPhone = function(idNumOrPhone,flag) {
		idNumOrPhone = idNumOrPhone || '';
		if(flag==0){
			return (idNumOrPhone.length == 11);
		}else{
			return (idNumOrPhone.length == 15 || idNumOrPhone.length== 18);
		}
	};
	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(forgetInfo, callback) {
		callback = callback || $.noop;
		forgetInfo = forgetInfo || {};
		forgetInfo.idNum = forgetInfo.idNum || '';
		forgetInfo.password = forgetInfo.password || '';
		forgetInfo.password_confirm = forgetInfo.password_confirm || '';
		forgetInfo.code = forgetInfo.code || '';
		if(forgetInfo.password.length<8 ||forgetInfo.password.length>18 ){
			return callback('密码8-18位由字母、数字或符号组成');
		}
		if(forgetInfo.password!=forgetInfo.password_confirm){
			return callback('两次密码输入不一致');
		}
		if(forgetInfo.password==""||forgetInfo.password_confirm==""||forgetInfo.code==""){
			return callback('全为必填项');
		}
		var severUrl=owner.getseverUrl()+"home/AppForgetPwd";
		mui.ajax(severUrl,{
			data:{
				IdNum:forgetInfo.idNum,
				PassWord:forgetInfo.password,
				Code:forgetInfo.code,
				Phone:forgetInfo.phone,
				IsNewApp:forgetInfo.isnewapp,
			},
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:50000,//超时时间设置为3分钟；
			success:function(data){//服务器返回响应，根据响应结果，分析是否登录成功；
				if(data.IsOk)
				{
					return callback();
				}
				else
				{
					return callback(data.Msg);
				}
			},
			error:function(xhr,type,errorThrown){
				state='{}',
				owner.setState(state);
				return callback('请求超时');
			}
		});
	};
	
	//获取验证码 
	//服务器端 参数  KeyWord,type
	//flag:0手机 1身份证 
	owner.getCode = function(idNumOrPhone,flag,smsType, callback) {
		if(!checkIdnumOrPhone(idNumOrPhone,flag)){
			if(flag==0){
				return callback("手机号输入有误");
			}else{
				return callback("身份证号输入有误");
			}
		}
		var severUrl=owner.getseverUrl()+"home/AppGetCode";
		var checkValue=false;
		if(smsType==0){
			checkValue=true;
		}
		mui.ajax(severUrl,{
			data:{
				KeyWord:idNumOrPhone,
				Type:flag,
				SmsType:smsType,
				CheckValue:checkValue
			},
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:50000,//超时时间设置为3分钟；
			success:function(data){//服务器返回响应，根据响应结果，分析是否登录成功；
				return callback(data.Msg);
			},
			error:function(xhr,type,errorThrown){
				state='{}',
				owner.setState(state);
				return callback('请求超时');
			}
		});
	};
	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function() {
		localStorage.setItem('$imgUrl', "http://114.215.195.208:8090/");
		localStorage.setItem('$severUrl',"http://114.55.93.71:8091/");//生产服务器
//		localStorage.setItem('$severUrl',"http://192.168.1.117:53559/");//测试		
//		localStorage.setItem('$imgUrl', "http://114.55.56.249:8094/");//测试
		//localStorage.setItem('$severUrl',"http://120.27.128.51:10020/");//测试服务器
//		localStorage.setItem('$severUrl',"http://localhost:53559/");//测试
		//localStorage.setItem('$severUrl',"http://192.168.1.101:53559/");//测试
//		localStorage.setItem('$imgUrl',"http://192.168.1.101:8131/");
	}
	owner.getImgUrl=function()
	{
		var severUrl=localStorage.getItem('$imgUrl') || "";
		return severUrl;
	}
	owner.getseverUrl=function()
	{
		var severUrl=localStorage.getItem('$severUrl') || "";
		return severUrl;
	}
	owner.polling=function()
	{
		var state = owner.getState();
		var severUrl=owner.getseverUrl()+"home/CheckMemberInfo";
		mui.ajax(severUrl,{
			data:{
				//phoneNum:state.account
			},
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				//服务器返回响应，根据响应结果，分析是否登录成功；
				//alert(JSON.stringify(data));
			},
			error:function(xhr,type,errorThrown){
			//异常处理；
			//console.log(type);
			}
		});
	}

	//flag=1 后台添加图片
	owner.imgurl=function(url,flag){
			url="http://114.215.195.208:8090/Content/Upload/"+url;
            //url="http://114.55.56.249:8094/Content/Upload/"+url;//测试
            return url;
        }

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			
			return JSON.parse(settingsText);
		}
	//将C#的日期json串，转为人能看得懂的日期字符串
	owner.splitDate = function(s) {
	    s.replace(/Date\([\d+]+\)/, function (a) { eval('d = new ' + a) });
	    return d.format("yyyy-MM-dd hh:mm:ss");
	}
	Date.prototype.format = function (format) {
	    var o = {
	        "M+": this.getMonth() + 1, //month 
	        "d+": this.getDate(), //day 
	        "h+": this.getHours(), //hour 
	        "m+": this.getMinutes(), //minute 
	        "s+": this.getSeconds(), //second 
	        "q+": Math.floor((this.getMonth() + 3) / 3), //quarter 
	        "S": this.getMilliseconds() //millisecond 
	    }
	
	    if (/(y+)/.test(format)) {
	        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	    }
	
	    for (var k in o) {
	        if (new RegExp("(" + k + ")").test(format)) {
	            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
	        }
	    }
	    return format;
	}
		/**
		 * 获取本地是否安装客户端
		 **/
	owner.isInstalled = function(id) {
		if (id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if (mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch (e) {}
		} else {
			switch (id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
	
	owner.sortByKeyEsc=function(array, key) {
		//升序
	    return array.sort(function(a, b) {
	        var x = a[key]; var y = b[key];
	        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	    });
	}
	owner.sortByKeyDesc	=function(array, key) {
		//降序
	    return array.sort(function(a, b) {
	        var x = a[key]; var y = b[key];
	        return ((x > y) ? -1 : ((x < y) ? 1 : 0));
	    });
	}
	
	owner.sysLogin=function(){
		var urlStr="../login.html";
		var idStr="login";
		if(localStorage.getItem('$UserId')){
			urlStr= "../unlockLogin.html"
			idStr="unlockLogin.html";
		}
		mui.openWindow({
			url: urlStr,
		    id:idStr,
		    show:{
		      autoShow:true,
		       duration:200//
		    },
		    waiting:{
		      autoShow:false
			}
		});
	}

}(mui, window.app = {}));